require 'httparty'
require 'json'
require 'nusmods/endpoints'

module NUSMods
  class Client

    include Endpoints

    def initialize(opts = {})
      @base_url = "http://api.nusmods.com/"
    end

    private

    attr_accessor :conn

    def get(url)
      JSON.parse(HTTParty.get(@base_url + url).body)
    end

    # Converts a provided year to the API requirements
    def format_year(year)
      "#{year}-#{year+1}"
    end

  end
end
